//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2021-11-22 11:27:53 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------
using IRaCIS.Core.Domain.Share;

namespace IRaCIS.Core.Application.Contracts
{
    /// <summary> PreviousSurgeryView  列表视图模型 </summary>
    public class PreviousSurgeryView
    {
        public Guid Id { get; set; }
        public DateTime CreateTime { get; set; }
        public string CreateUser { get; set; } = string.Empty;
        public DateTime? OperationTime { get; set; }
        public Guid SubjectVisitId { get; set; }
        public bool IsSubjectLevel { get; set; }
        public string Path { get; set; } = string.Empty;
        public string FileName { get; set; } = string.Empty;
        public string OperationName { get; set; } = string.Empty;
        //public Guid SubjectId { get; set; }
        public Guid CreateUserId { get; set; }

        public Guid ClinicalDataTrialSetId { get; set; }

        public string FullFilePath => Path;
    }

    ///<summary>PreviousSurgeryQuery  列表查询参数模型</summary>
    public class PreviousSurgeryQuery
    {
        public bool? IsSubjectLevel { get; set; }
        public string OperationName { get; set; } = string.Empty;

    }

    public class PreviousSurgeryAddOrEdit
    {
        public Guid? Id { get; set; }
    
        public DateTime? OperationTime { get; set; }
        public Guid? SubjectVisitId { get; set; }
        public bool IsSubjectLevel { get; set; } = true;
        public string Path { get; set; } = String.Empty;
        public string FileName { get; set; } = String.Empty;
        public string OperationName { get; set; } = string.Empty;


        /// <summary>
        /// 临床数据类型Id
        /// </summary>
        public Guid ClinicalDataTrialSetId { get; set; }
        //public Guid SubjectId { get; set; }
    }

    public class PreviousPDFView
    {
        public Guid Id { get; set; }
        public DateTime CreateTime { get; set; }
        public Guid SubjectVisitId { get; set; }
        public string Path { get; set; } = string.Empty;
        public string FileName { get; set; } = string.Empty;
        public Guid CreateUserId { get; set; }

        public string FullFilePath => Path;


        /// <summary>
        /// 是否是检查批次
        /// </summary>
        public bool? IsVisist { get; set; }

        /// <summary>
        /// 临床级别
        /// </summary>
        public ClinicalLevel? ClinicalLevel { get; set; }

        /// <summary>
        /// 数据类型
        /// </summary>
        public ClinicalDataType? DataType { get; set; }

        /// <summary>
        /// 上传方式
        /// </summary>
        public ClinicalUploadType? UploadType { get; set; }

        /// <summary>
        /// 项目Id
        /// </summary>
        public Guid? TrialId { get; set; }

        /// <summary>
        /// 患者ID
        /// </summary>
        public Guid? SubjectId { get; set; }
    }

   

    ///<summary> PreviousPDFAddOrEdit  列表查询参数模型</summary>
    public class PreviousPDFAddOrEdit
    {
        public Guid? Id { get; set; }
        public Guid SubjectVisitId { get; set; }
        public string Path { get; set; } = string.Empty;
        public string FileName { get; set; } = string.Empty;

        /// <summary>
		/// 是否是检查批次
		/// </summary>
		public bool? IsVisist { get; set; }

        /// <summary>
        /// 临床级别
        /// </summary>
        public ClinicalLevel? ClinicalLevel { get; set; }

        /// <summary>
        /// 数据类型
        /// </summary>
        public ClinicalDataType? DataType { get; set; }

        /// <summary>
        /// 上传方式
        /// </summary>
        public ClinicalUploadType? UploadType { get; set; }

        /// <summary>
        /// 项目Id
        /// </summary>
        public Guid? TrialId { get; set; }

        /// <summary>
        /// 患者ID
        /// </summary>
        public Guid? SubjectId { get; set; }
    }


}


