﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Application.ViewModel
{
    public class AddTaskLesionAnswerFromLastTaskInDto
    {
        public Guid VisitTaskId { get; set; }
    }

    public class VisitStudyTime
    {
        /// <summary>
        /// 检查批次Id
        /// </summary>
        public Guid SubjectVisitId { get; set; }

        public DateTime? StudyTime { get; set; }
    }

    public class SiteVisitForTumor
    {
        /// <summary>
        /// 检查批次Id
        /// </summary>
        public Guid VisitTaskId { get; set; }

        public Guid? SubjectVisitId { get; set; }

        /// <summary>
        /// 任务Num
        /// </summary>
        public decimal VisitTaskNum { get; set; }

        /// <summary>
        /// 检查日期
        /// </summary>
        public DateTime? StudyTime { get; set; }

      
    }

    public class AddTaskLesionAnswerFromLastTaskOutDto
    {
        public bool IsBaseLine { get; set; }
    }
}
